//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

import java.io.*;

public class CCalcTime extends Dialog implements ActionListener, Runnable
{
  //Variables
  Dimension size;

  Label comp1;
  Button comp2;

  String str2="Cancel";
  
  Frame Parent=null;

  Thread thrd=null;

  int Status;

  CGlobal g=null;

  int index=0;

  int ret=0;

  String str="";

  String str_fl="";
  String str_flx="";

  // *******************************************************************
  public CCalcTime(Frame dw, CGlobal glob, int index1, String str_fl1, String str_fl2)
  {                                                                
    super(dw, "Calculating time ...", true);

    Status=-1;
    index=index1;
    str_fl=str_fl1;
    str_flx=str_fl2;

    Parent=dw;

    int gap=10;

    g=glob;

    //First panel for border
    Panel p=new Panel();
    FlowLayout lt=new FlowLayout(FlowLayout.CENTER);
    lt.setHgap(gap);
    lt.setVgap(gap);

    setLayout(lt);
    add(p);

    BorderLayout lt0=new BorderLayout();
    lt0.setHgap(gap);
    lt0.setVgap(gap);

    FlowLayout lt1=new FlowLayout(FlowLayout.CENTER);

    FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);

    Panel p0=new Panel();
    p0.setLayout(lt0);
  
    CFramedArea p1=new CFramedArea();
    p1.setLayout(lt1);

    Panel p2=new Panel();
    p2.setLayout(lt2);

    comp1=new Label("______________________________________________________________________________", Label.CENTER);

    comp2=new Button(str2);
    comp2.addActionListener(this);

    p.add(p0);
	
    p0.add("North", p1);
    p0.add("South", p2);

    p1.add(comp1);

    p2.add(comp2);

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    setResizable(false);

    //Packing elements in window
    pack();

//    comp1.setText("");

    size=getSize();
		
    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
    AWTEvent.COMPONENT_EVENT_MASK);

    thrd=new Thread(this);
    thrd.start();		

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String command = e.getActionCommand();

    if (command.equals(str2))
    {	
      close_window();

      Status=-1;

      thrd.stop();

      dispose();
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      close_window();

      Status=-1;

      thrd.stop();

      dispose();
    }
  }

  // *******************************************************************
  public void run()
  { 
    comp1.setText("______________________________________________________________________________");
    try
    {
      thrd.sleep(50);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    //
    try
    {
      thrd.sleep(500);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread!");
      System.exit(1);
    }

    int i1=0;
    int i2=0;

    comp1.setText("Loading and processing file with number of memory accesses ...");

    //get platform parameters
    String fr=g.plt.GetConfig(index).GetParamStr(g.pltFreq);
    String mem=g.plt.GetConfig(index).GetParamStr(g.pltMemory);
    String cl1=g.plt.GetConfig(index).GetParamStr(g.pltCacheL1);
    String cl2=g.plt.GetConfig(index).GetParamStr(g.pltCacheL2);

    String mem_a="";
    String mem_b="";
    String cl1_a="";
    String cl1_b="";
    String cl2_a="";
    String cl2_b="";

    i1=mem.indexOf(",");
    if (i1!=-1)
    {
      mem_a=mem.substring(0,i1).trim();
      mem_b=mem.substring(i1+1,mem.length()).trim();
    }

    i1=cl1.indexOf(",");
    if (i1!=-1)
    {
      cl1_a=cl1.substring(0,i1).trim();
      cl1_b=cl1.substring(i1+1,cl1.length()).trim();
    }

    i1=cl2.indexOf(",");
    if (i1!=-1)
    {
      cl2_a=cl2.substring(0,i1).trim();
      cl2_b=cl2.substring(i1+1,cl2.length()).trim();
    }

    double fr_d=0; try {fr_d=Double.valueOf(fr).doubleValue()*1000000;}
    catch (NumberFormatException nfe1){}

    double mem_ad=0; try {mem_ad=Double.valueOf(mem_a).doubleValue()*1024*1024;}
    catch (NumberFormatException nfe1){}
    double mem_bd=0; try {mem_bd=Double.valueOf(mem_b).doubleValue()*1024*1024;}
    catch (NumberFormatException nfe1){}

    double cl1_ad=0; try {cl1_ad=Double.valueOf(cl1_a).doubleValue()*1024;}
    catch (NumberFormatException nfe1){}
    double cl1_bd=0; try {cl1_bd=Double.valueOf(cl1_b).doubleValue()*1024*1024;}
    catch (NumberFormatException nfe1){}

    double cl2_ad=0; try {cl2_ad=Double.valueOf(cl2_a).doubleValue()*1024;}
    catch (NumberFormatException nfe1){}
    double cl2_bd=0; try {cl2_bd=Double.valueOf(cl2_b).doubleValue()*1024*1024;}
    catch (NumberFormatException nfe1){}

    //array
    int imax=4096;
    double[] nc1=new double [imax];
    double[] naf1=new double [imax];
    double[] nat1=new double [imax];   
    double[] nsaf1=new double [imax];
    double[] nsat1=new double [imax];   
    double[] nafa1=new double [imax];
    double[] nsafa1=new double [imax];   

    for (int i=0; i<imax; i++)
    {
      nc1[i]=0;
      naf1[i]=0;
      nat1[i]=0;
      nsaf1[i]=0;
      nsat1[i]=0;
      nafa1[i]=0;
      nsafa1[i]=0;
    }

    String str1="";
    String nc="";
    String naf="";
    String nat="";
    String nsaf="";
    String nsat="";

    int prc_max=0;

    //load file
    BufferedReader fin=null;

    try
    {
      fin=new BufferedReader(new FileReader(str_fl));
    }
    catch (IOException e2)
    {
      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening input file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    try
    {
      while ((str1=fin.readLine())!=null)
      {
        i1=str1.indexOf("proc={");
        if (i1!=-1)
        {
          i2=str1.indexOf("}", i1);
          String prc=str1.substring(i1+6, i2).trim();

          nc="";
          i1=str1.indexOf("ncalls={");
          if (i1!=-1)
          {
            i2=str1.indexOf("}", i1);
            nc=str1.substring(i1+8, i2).trim();
          }

          naf="";
          i1=str1.indexOf("naccessfirst={");
          if (i1!=-1)
          {
            i2=str1.indexOf("}", i1);
            naf=str1.substring(i1+14, i2).trim();
          }

          nat="";
          i1=str1.indexOf("naccesstotal={");
          if (i1!=-1)
          {
            i2=str1.indexOf("}", i1);
            nat=str1.substring(i1+14, i2).trim();
          }

          nsaf="";
          i1=str1.indexOf("nsizeaccessfirst={");
          if (i1!=-1)
          {
            i2=str1.indexOf("}", i1);
            nsaf=str1.substring(i1+18, i2).trim();
          }

          nsat="";
          i1=str1.indexOf("nsizeaccesstotal={");
          if (i1!=-1)
          {
            i2=str1.indexOf("}", i1);
            nsat=str1.substring(i1+18, i2).trim();
          }

          int prc_i=0; try {prc_i=Integer.valueOf(prc).intValue();}
          catch (NumberFormatException nfe1){}
          double nc_d=0; try {nc_d=Double.valueOf(nc).doubleValue();}
          catch (NumberFormatException nfe1){}
          double naf_d=0; try {naf_d=Double.valueOf(naf).doubleValue();}
          catch (NumberFormatException nfe1){}
          double nat_d=0; try {nat_d=Double.valueOf(nat).doubleValue();}
          catch (NumberFormatException nfe1){}
          double nsaf_d=0; try {nsaf_d=Double.valueOf(nsaf).doubleValue();}
          catch (NumberFormatException nfe1){}
          double nsat_d=0; try {nsat_d=Double.valueOf(nsat).doubleValue();}
          catch (NumberFormatException nfe1){}

          double nafa_d=0;
          double nsafa_d=0;
          if (nc_d!=0)
          {
            nafa_d=Math.ceil(nat_d/nc_d);
            nsafa_d=Math.ceil(nsat_d/nc_d);
          }

          if (prc_i>prc_max) prc_max=prc_i;

          if (!nc.equals("")) nc1[prc_i]=nc_d;
          if (!naf.equals("")) naf1[prc_i]=naf_d;
          if (!nat.equals("")) nat1[prc_i]=nat_d;
          if (!nsaf.equals("")) nsaf1[prc_i]=nsaf_d;
          if (!nsat.equals("")) nsat1[prc_i]=nsat_d;
          if (!naf.equals("")) nafa1[prc_i]=nafa_d;
          if (!nsaf.equals("")) nsafa1[prc_i]=nsafa_d;
        }
      }
    }
    catch (Exception e2)
    {
      try
      {
        fin.close();
      }
      catch (Exception e3)
      {}

      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while processing input file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    try
    {
      fin.close();
    }
    catch (Exception e5)
    {
    }

    BufferedWriter fout=null;

    try
    {
      fout=new BufferedWriter(new FileWriter(str_flx));
    }
    catch (IOException e2)
    {
      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening output file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    try
    {
      for (int i=0; i<=prc_max; i++)
      {
        fout.write("***************************************************************");fout.newLine();
        fout.write("Analysis for procedure: "+String.valueOf(i));fout.newLine();

        fout.newLine();

        fout.write("Number of calls: "+String.valueOf(nc1[i]));fout.newLine();

        fout.newLine();

        fout.write("Number of memory accesses (total):               "+CMisc.align_str(String.valueOf(nat1[i]),20));fout.newLine();
        fout.write("Number of memory accesses (first call):          "+CMisc.align_str(String.valueOf(naf1[i]),20));fout.newLine();
        fout.write("Number of memory accesses (per call, average):   "+CMisc.align_str(String.valueOf(nafa1[i]),20));fout.newLine();

        if (nsat1[i]!=0)
        {
          fout.newLine();

          fout.write("Memory size (total):               "+CMisc.align_str(String.valueOf(nsat1[i]),20));fout.newLine();
          fout.write("Memory size (first call):          "+CMisc.align_str(String.valueOf(nsaf1[i]),20));fout.newLine();
          fout.write("Memory size (per call, average):   "+CMisc.align_str(String.valueOf(nsafa1[i]),20));fout.newLine();
        }

        if ((naf1[i]!=nafa1[i]) || (nsaf1[i]!=nsafa1[i]))
        {
          fout.newLine();

          if (naf1[i]!=nafa1[i])
          {
            fout.write("Different memory access number detected!");fout.newLine();
          }

          if (nsaf1[i]!=nsafa1[i])
          {
            fout.write("Different memory size detected!");fout.newLine();
          }
        }

        if (nsaf1[i]!=0)
        {
          fout.newLine();

          fout.write("Platform L1 size:                "+CMisc.align_str(String.valueOf(cl1_ad),10));fout.newLine();
          fout.write("Platform L2 size:                "+CMisc.align_str(String.valueOf(cl2_ad),10));fout.newLine();
          fout.write("Platform Main Memory size:       "+CMisc.align_str(String.valueOf(mem_ad),10));fout.newLine();
          fout.write("Memory size (per call, average): "+CMisc.align_str(String.valueOf(nsafa1[i]),10));fout.newLine();

          fout.newLine();

//          fout.write("If application has good interprocedural locality then: ");fout.newLine();
          if (nsafa1[i]<cl1_ad)
          {
            fout.write("Memory access to L1 will dominate!");fout.newLine();
          }
          else if (nsafa1[i]<cl2_ad)
          {
            fout.write("Memory access to L2 will dominate!");fout.newLine();
          }
          else if (nsafa1[i]<mem_ad)
          {
            fout.write("Memory access to Main Memory will dominate!");fout.newLine();
          }
          else
          {
            fout.write("Memory access to Main Memory and Swapping Pages will dominate!");fout.newLine();
          }
        }

        double p1=0; //domination by Main Memory (good stride)
        double p2=0; //domination by L2
        double p3=0; //domination by L1

        double ncx=nc1[i]-1;
        if (ncx<1) ncx=0;

        if (mem_bd!=0) p1=nsat1[i]/mem_bd;
        if (cl2_bd!=0) p2=nsat1[i]/cl2_bd;
        if (cl1_bd!=0) p3=nat1[i]/cl1_bd;

        fout.newLine();

        if (mem_bd!=0) fout.write("Time (MM dominates, memory footprint) ="+String.valueOf(p1)); fout.newLine();
        if (cl2_bd!=0) fout.write("Time (L2 dominates, memory footprint) ="+String.valueOf(p2)); fout.newLine();
        if (cl1_bd!=0) fout.write("Time (L1 dominates, memory access)    ="+String.valueOf(p3)); fout.newLine();
      }
    }
    catch (Exception e2)
    {
      try
      {
        fout.close();
      }
      catch (Exception e3)
      {}

      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while processing output file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    try
    {
      fout.close();
    }
    catch (Exception e5)
    {
    }

    try
    {
      thrd.sleep(1000);
    }
    catch (InterruptedException e)
    {
      System.out.println("Fatal Error occured during work with thread in CCleanDir.class!");
      System.exit(1);
    }

    Status=0;
    dispose();
  }

  // *******************************************************************
  public int getStatus()
  {
    return Status;
  }

  // *******************************************************************
  public void close_window()
  {
  }
}
