//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class CEditPrjA_File extends Dialog implements ActionListener
{
  //Variables
  CGlobal g=null;

  Dimension size;

  List lst=null;
  TextField tf=null;

  Button bt1=null;
  String str1="Starting position";

  Button bt2=null;
  String str2="Ending position";

  Button bt3=null;
  String str3="Extract";

  Button bt4=null;
  String str4="Start search";

  Button bt5=null;
  String str5="Continue search";

  Button bt6=null;
  String str6="Ok";

  CProject cp=null;

  String prj_name="";

  Frame Parent=null;

  String file_name="";
  String file_ext="";

  int pos_start=0;
  int pos_end=0;

  int index=0;

  boolean extract=false;

  // *******************************************************************
  public CEditPrjA_File(Frame dw, CGlobal glob, 
                        int index1, CProject cp1, String prj_name1)
  {
    super(dw, "Edit file from prj_a", true);
 
    g=glob;

    Parent=dw;

    pos_start=0;
    pos_end=0;

    cp=cp1;

    extract=false;

    int gap=3;

    index=index1;

    prj_name=prj_name1;

    file_name=cp.GetFileName(index);
    file_ext=cp.GetFileExt(index);

    Panel p1a1=new Panel();
    lst=new List(30);
    lst.add("______________________________________________________________________________");

    p1a1.add(lst);

    Panel p1a2=new Panel();
    bt1=new Button(str1);
    bt1.addActionListener(this);
    bt2=new Button(str2);
    bt2.addActionListener(this);
    bt3=new Button(str3);
    bt3.addActionListener(this);
    p1a2.add(bt1);
    p1a2.add(bt2);
    p1a2.add(bt3);

    Panel p1a=new Panel();
    BorderLayout lt1a=new BorderLayout();
    lt1a.setHgap(gap);
    lt1a.setVgap(gap);
    p1a.setLayout(lt1a);

    p1a.add(p1a1, "North");
    p1a.add(p1a2, "South");

    Panel p1c1=new Panel();
    bt4=new Button(str4);
    bt4.addActionListener(this);
    tf=new TextField("", 40);
    bt5=new Button(str5);
    bt5.addActionListener(this);
    p1c1.add(bt4);
    p1c1.add(tf);
    p1c1.add(bt5);

    Panel p1c2=new Panel();
    bt6=new Button(str6);
    bt6.addActionListener(this);
    p1c2.add(bt6);

    Panel p1c=new Panel();
    BorderLayout lt1c=new BorderLayout();
    lt1c.setHgap(gap);
    lt1c.setVgap(gap);
    p1c.setLayout(lt1c);

    p1c.add(p1c1, "North");
    p1c.add(p1c2, "South");

    //First panel for border
    BorderLayout lt1=new BorderLayout();
    lt1.setHgap(gap);
    lt1.setVgap(gap);
    Panel p1=new Panel();
    p1.setLayout(lt1);

    p1.add(p1a, "North");
    p1.add(p1c, "South");

    add(p1);

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    //Packing elements in window
    pack();

    lst.removeAll();

    //loading file
    BufferedReader fin=null;

    String str=g.cfg.GetParamStr(g.cfgPath);
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.prj_path1;
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=file_name+file_ext;

    try
    {
      fin=new BufferedReader(new FileReader(str));
    }
    catch (IOException e2)
    {
      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    String str1="";
    try
    {
      while ((str1=fin.readLine())!=null)
      {
        lst.add(str1);
      }
    }
    catch (Exception e2)
    {
      try
      {
        fin.close();
      }
      catch (Exception e3)
      {}

      CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while loading file!");
      mb=null;

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }

    try
    {
      fin.close();
    }
    catch (Exception e5)
    {
    }

    size=getSize();
		
    //Initializing parameters
    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
                 AWTEvent.COMPONENT_EVENT_MASK);

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String cm = e.getActionCommand();

    if (cm.equals(str1)) 
    {	        
      pos_start=lst.getSelectedIndex();
    } 
    else if (cm.equals(str2)) 
    {	        
      pos_end=lst.getSelectedIndex();
    }
    else if (cm.equals(str3)) 
    {	        
      if (pos_start!=0 && pos_end!=0)
      {
        BufferedWriter fout=null;

        boolean found=false;
        String str="";
        int eos_cur=0;

        while (!found)
        {
          eos_cur++;

          str=g.cfg.GetParamStr(g.cfgPath);
          if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
          str+=g.prj_path1;
          if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
          str+=file_name+"_"+g.prj_add_a1+"_"+String.valueOf(eos_cur)+file_ext;

          if (!CMisc.isFileExist(str)) found=true;
        }

        try
        {
          fout=new BufferedWriter(new FileWriter(str));
        }
        catch (IOException e1)
        {
          CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening file!");
          mb=null;

          System.gc();
          System.runFinalization();

          dispose();
        
          return;
        }

        try
        {
          for (int i=pos_start; i<=pos_end; i++)
          {
            fout.write(lst.getItem(pos_start));
            fout.newLine();

            lst.remove(pos_start);
          }
        }
        catch (Exception e2)
        {
          try
          {
            fout.close();
          }
          catch (Exception e3)
          {}

          CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem saving file!");
          mb=null;

          System.gc();
          System.runFinalization();

          dispose();
        
          return;
        }

        try
        {
          fout.close();
        }
        catch (Exception e5)
        {}

        cp.AddLine1(cp.GetLngNameOrig(index),
                    file_name+"_"+g.prj_add_a1+"_"+String.valueOf(eos_cur),
                    file_ext,
                    g.prj.GetExtraOpt(index));

        cp.Save();

        extract=true;
      }
    } 
    else if (cm.equals(str4) || cm.equals(str5)) 
    {	        
      int im=lst.getItemCount();
      int i=0;
      if (cm.equals(str5)) i=lst.getSelectedIndex()+1;

      String str1=tf.getText().toLowerCase();

      for (; i<im; i++)
      {     
        String str=lst.getItem(i).toLowerCase();
        if (str.indexOf(str1)!=-1)
        {
          lst.select(i);
          break;
        }
      }
    } 
    else if (cm.equals(str6)) 
    {	        
      if (extract)
      {
        BufferedWriter fout=null;

        boolean found=false;
        String str="";
        int eos_cur=-1;

        while (!found)
        {
          eos_cur++;

          str=g.cfg.GetParamStr(g.cfgPath);
          if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
          str+=g.prj_path1;
          if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
          str+=file_name+"_"+g.prj_add_a1+"_"+String.valueOf(eos_cur)+file_ext;

          if (!CMisc.isFileExist(str)) found=true;
        }

        try
        {
          fout=new BufferedWriter(new FileWriter(str));
        }
        catch (IOException e1)
        {
          CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening file!");
          mb=null;
   
          System.gc();
          System.runFinalization();

          dispose();
        
          return;
        }

        int i=0;
        int im=lst.getItemCount();

        try
        {
          for (i=0; i<im; i++)
          {
            fout.write(lst.getItem(i));
            fout.newLine();
          }
        }
        catch (Exception e2)
        {
          try
          {
            fout.close();
          }
          catch (Exception e3)
          {}

          CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem saving file!");
          mb=null;

          System.gc();
          System.runFinalization();

          dispose();
      
          return;
        }

        try
        {
          fout.close();
        }
        catch (Exception e5)
        {}

        //remove old file from the project
        CProject cp1 = new CProject();

        if (cp1.Init(cp, prj_name)!=0)
        {
          CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error (internal): Can't initialize object CProject!");
          mb=null;

          System.gc();
          System.runFinalization();

          return;
        }

        for (i=1; i<cp.GetNumFiles(); i++)
        {
          if (!(file_name.equals(cp.GetFileName(i)) &&
              file_ext.equals(cp.GetFileExt(i))))
          {
            cp1.AddLine1(cp.GetLngNameOrig(i), cp.GetFileName(i), cp.GetFileExt(i), cp.GetExtraOpt(i));
          }
        }

        cp1.AddLine1(cp.GetLngNameOrig(index), file_name+"_"+g.prj_add_a1+"_"+String.valueOf(eos_cur), file_ext, cp.GetExtraOpt(index));

        cp1.Save();
      }

      System.gc();
      System.runFinalization();

      dispose();
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

//    if (e.getID() == Event.WINDOW_DESTROY)
//    {
//      dispose();
//    }
  }

  // *******************************************************************
  public void update_list()
  {
  }
}
