//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class CEditTree extends Dialog implements ActionListener, ItemListener
{
  //Variables
  CGlobal g=null;

  Dimension size;

  TextArea ta=null;
  Button   bt1=null;
  String   bs1="Ok";
  Button   bt2=null;
  String   bs2="Cancel";

  Frame Parent=null;

  String fn="";

  // *******************************************************************
  public CEditTree(Frame dw, CGlobal glob)
  {
    super(dw, "Edit tree", true);
 
    g=glob;

    Parent=dw;

    int gap=3;

    Panel p1a=new Panel();
    ta=new TextArea(20, 80);
    p1a.add(ta);

    Panel p1b=new Panel();
    bt1=new Button(bs1);
    bt1.addActionListener(this);    
    bt2=new Button(bs2);
    bt2.addActionListener(this);    
    p1b.add(bt1);
    p1b.add(bt2);

    Panel p1=new Panel();
    BorderLayout lt1=new BorderLayout();
    lt1.setHgap(gap);
    lt1.setVgap(gap);
    p1.setLayout(lt1);

    p1.add(p1a, "North");
    p1.add(p1b, "South");

    add(p1);

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    //Packing elements in window
    pack();

    //loading file
    BufferedReader fin=null;

    String str=g.cfg.GetParamStr(g.cfgPath);
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.prj_path1;
    if (!str.equals("")) str=CMisc.ProcessDir(str, g.cfg.GetParamStr(g.cfgSep));
    str+=g.f_diag19a+"_2";

    fn=str;

    //check for info file
    if (CMisc.isFileExist(fn))
    {
      try
      {
        fin=new BufferedReader(new FileReader(str));
      }
      catch (IOException e2)
      {
        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening tree file!");
        mb=null;

        System.gc();
        System.runFinalization();

        dispose();
        
        return;
      }

      String str1="";

      try
      {
        while ((str1=fin.readLine())!=null)
        {
          ta.append(str1+"\n");
        }
      }
      catch (Exception e2)
      {
        try
        {
          fin.close();
        }
        catch (Exception e3)
        {}

        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while loading tree file!");
        mb=null;

        System.gc();
        System.runFinalization();

        dispose();
         
        return;
      }

      try
      {
        fin.close();
      }
      catch (Exception e5)
      {
      }
    }

    size=getSize();
		
    //Initializing parameters
    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
                 AWTEvent.COMPONENT_EVENT_MASK);

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String cm = e.getActionCommand();

    if (cm.equals(bs1)) 
    {	        
      String str1=ta.getText();

      BufferedWriter fout=null;

      try
      {
        fout=new BufferedWriter(new FileWriter(fn));
      }
      catch (IOException e2)
      {
        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem opening file!");
        mb=null;

        System.gc();
        System.runFinalization();

        dispose();
        
        return;
      }

      try
      {
        fout.write(str1);
      }
      catch (Exception e2)
      {
        try
        {
          fout.close();
        }
        catch (Exception e3)
        {}

        CMsgBoxD mb=new CMsgBoxD(Parent, this, 1, "Error: Problem while writing tree file!");
        mb=null;

        System.gc();
        System.runFinalization();

        dispose();
         
        return;
      }

      try
      {
        fout.close();
      }
      catch (Exception e5)
      {
      }

      System.gc();
      System.runFinalization();

      dispose();
        
      return;
    }
    else if (cm.equals(bs2)) 
    {	        

      System.gc();
      System.runFinalization();

      dispose();
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      dispose();
    }
  }

  // *******************************************************************
  public void itemStateChanged(ItemEvent e1)
  {
  }
}
