//
// Class Misc with misc functions
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.io.*;

public class CMisc
{
  //**************************************************************************
  public static String ProcessDir(String dir, String sep)
  {
    String newdir="";
    char sp=sep.charAt(0);
    char ch=0;

    for (int i=0; i<dir.length(); i++)
    {
      ch=dir.charAt(i);
      if ((ch=='\\') || (ch=='/')) ch=sp;
      newdir+=ch;
    }

    if (ch!=sp) newdir+=sp;

    return newdir;
  }

  //**************************************************************************
  public static String ProcessPath(String dir, String sep)
  {
    String newdir="";
    char sp=sep.charAt(0);
    char ch=0;

    for (int i=0; i<dir.length(); i++)
    {
      ch=dir.charAt(i);
      if ((ch=='\\') || (ch=='/')) ch=sp;
      newdir+=ch;
    }

    return newdir;
  }

  //**************************************************************************
  //Return: >=0 - Number of Lines in File
  //         -1 - Error
  public static int GetNumOfLines(String fname)
  {
    int num=0;
    BufferedReader fin=null;

    try
    {
      fin=new BufferedReader(new FileReader(fname));
    }
    catch (IOException e2)
    {
      return -1;
    }

    String str1="";

    try
    {
      while ((str1=fin.readLine())!=null)
      {
        num++;
      }
    }
    catch (Exception e1)
    {
      try
      {
        fin.close();
      }
      catch (Exception e2)
      {}
      return -1;
    }

    try
    {
      fin.close();
    }
    catch (Exception e3)
    {}

    return num;
  }      

  //**************************************************************************
  //Return: = 0 - Success
  //         -1 - Error
  public static int CopyTextFile(String fname_in, String fname_out)
  {
    long num=0;
    BufferedReader fin=null;
    BufferedWriter fout=null;

    try
    {
      fin =new BufferedReader(new FileReader(fname_in));
      fout=new BufferedWriter(new FileWriter(fname_out));
    }
    catch (IOException e2)
    {
      return -1;
    }

    String str1="";

    try
    {
      while ((str1=fin.readLine())!=null)
      {
        fout.write(str1);
        fout.newLine();
      }
    }
    catch (Exception e1)
    {
      try
      {
        fin.close();
        fout.close();
      }
      catch (Exception e2)
      {}
      return -1;
    }

    try
    {
      fin.close();
      fout.close();
    }
    catch (Exception e3)
    {}

    return 0;
  }      

  //**************************************************************************
  public static String tab2space(String str)
  {
    int i;
    String str1="";

    if (str!=null)
    {
      int len=str.length();
      if (len!=0)
      {
        for (i=0; i<len; i++)
        {
          char c=str.charAt(i);
          int num=c;
          num&=255;
          if (num==9)
          {
            str1+="        ";
          }
          else
          {
            str1+=String.valueOf(c);
          }
        }
      }
    }

    return str1;
  }

  //**************************************************************************
  public static String[] parse_prof(int max_prof_param, String str)
  {
    int i=0;
    int j=0;
    boolean p=false;

    String[] ProfParam=new String[max_prof_param];
    for (i=0; i<max_prof_param;i++) ProfParam[i]="";

    if (str!=null)
    {
      int len=str.length();
      if (len!=0)
      {
        for (i=0; (i<len) && (j<max_prof_param); i++)
        {
          char c=str.charAt(i);
          int num=c;
          num&=255;

          if (c==' ')
          {
            if (p==true)
            {
              p=false;
              j++;
            }
          }
          else
          {
            p=true;
            ProfParam[j]+=String.valueOf(c);
          }
        }
      }
    }

    return ProfParam;
  }

  //**************************************************************************
  //for windows
  public static String GetProcName0(String str)
  {
    if (str.equals("")) return str;

    String str1=str;
    if (str1.charAt(0)=='_') str1=str1.substring(1,str1.length());

    int i=str1.indexOf("@");
    if (i>0) str1=str1.substring(0, i);

    return str1;
  }

  //**************************************************************************
  //for linux
  public static String GetProcName1(String str)
  {
    if (str.equals("")) return str;

    String str1=str;
    if (str1.charAt(str1.length()-1)=='_') str1=str1.substring(0,str1.length()-1);

    return str1;
  }

  //**************************************************************************
  //for windows
  public static boolean isAllUpperCase(String str)
  {
    if (str.equals("")) return false;

    for (int i=0; i<str.length(); i++)
    {
      if (Character.isLowerCase(str.charAt(i))) return false;
    }

    return true;
  }

  //**************************************************************************
  public static String align_str(String str, int len)
  {
    String str1=str;

    int i1=str.length();
    
    if (i1<len)
    {
      for (int i=i1; i<len; i++)
      {
        str1=" "+str1;
      }
    }
    
    return str1;
  }

  //**************************************************************************
  public static String align_str1(String str, int len, char repl)
  {
    String str1=str;

    int i1=str.length();
    
    if (i1<len)
    {
      for (int i=i1; i<len; i++)
      {
        str1=repl+str1;
      }
    }
    
    return str1;
  }

  //**************************************************************************
  public static String align_long(long param, int len)
  {
    String str1=String.valueOf(param);

    return align_str(str1, len);
  }

  //**************************************************************************
  public static String align_double(double param, int before, int after)
  {
    String str1=String.valueOf(param);
    String str2="";
    String str1a="";
    String str2a="";

    int i,i1;

    i1=str1.indexOf(".");
    if (i1!=-1)
    {
      str2=str1.substring(i1+1, str1.length());
      str1=str1.substring(0, i1);
    }

    str1a=align_str(str1, before);

    i1=str2.length();
    if (i1>after) str2a=str2.substring(0, after);
    else 
    {
      str2a=str2;
      for (i=i1; i<after; i++)
      {
        str2a+="0";
      }
    }

    return str1a+"."+str2a;
  }

  //**************************************************************************
  public static int isCorrect(String filename)
  {
    BufferedReader fcmp;
    String str1;

    //Check correctness
    try
    {
      fcmp=new BufferedReader(new FileReader(filename));
    }
    catch (IOException e1)
    {
      return -1; 
    }

    try
    {
      str1=fcmp.readLine();
    }
    catch (Exception e2)
    {
      try
      {
        fcmp.close();
      }
      catch (Exception e3)
      {}
      return -2;
    }

    try
    {
      fcmp.close();
    }
    catch (Exception e5)
    {
      return -3; 
    }

    if (str1==null)
    {
      return -4; 
    }

    if (!str1.equals("1"))
    {
      return 0; 
    }

    return 1;
  }

  //**************************************************************************
  public static boolean isFileExist(String filename)
  {
    FileInputStream fin1=null;

    try
    {
      fin1=new FileInputStream(filename);
    }
    catch (FileNotFoundException e1)
    {
      return false;
    }

    try
    {
      fin1.close();
    }
    catch (Exception e4)
    {}

    return true;
  }

  //**************************************************************************
  public static String DecodeURL(String url)
  {
    String newurl="";

    char ch=0;

    for (int i=0; i<url.length(); i++)
    {
      ch=url.charAt(i);

      if (ch=='%')
      {
        String x="";
        x+=url.charAt(i+1);
        x+=url.charAt(i+2);
	int val=Integer.parseInt(x, 16);
	ch=(char)val;
	i+= 2;
      }    

      newurl+=ch;
    }

    newurl=newurl.replace('+', ' ');

    return newurl;
  }

  //**************************************************************************
  public static long FileCRC(String name)
  {
    long crc=0;
    int c;
    FileInputStream fin=null;

    try
    {
      fin=new FileInputStream(name);
    }
    catch (FileNotFoundException e1)
    {
      return -1;
    }

    try
    {
      while ((c=fin.read())!=-1) crc+=c;
    }
    catch (Exception e3)
    {
      try
      {
        fin.close();
      }
      catch (Exception e4)
      {}
      return -1;
    }

    try
    {
      fin.close();
    }
    catch (Exception e2)
    {
      return -1;
    }
    return crc;
  }

}
