//
// Process Messages
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.net.*;
import java.io.*;

public class ProcessMessages
{
  public ProcessMessages(Socket sockfd, CGlobal g)
  {
    int misc;

    //Initialize instructions (need to do it in each process!)
    CSIParse sip = new CSIParse();

    if (sip.Init(50, 0)!=0)
    //            |  |
    //            |  |------- Case Sensitive (0) or not (1)
    //            |
    //            |---------- Max Number of Options
    {
      System.out.println("\nError: Can't initialize object CSIParse!");
      return;
    }

    misc=0;
  
    char ch=0;
    misc =sip.Add("initiate",               1, ' ', "");   //Param  0
    misc+=sip.Add("terminate",              0, ch,  "");   //Param  1
    misc+=sip.Add("directory",              1, '=', "");   //Param  2
    misc+=sip.Add("file_project",           1, '=', "");   //Param  3
    misc+=sip.Add("file_tree_in",           1, '=', "");   //Param  4
    misc+=sip.Add("file_diag_out",          1, '=', "");   //Param  5
    misc+=sip.Add("strategy",               1, '=', "");   //Param  6
    misc+=sip.Add("step",                   1, '=', "");   //Param  7
    misc+=sip.Add("precision",              1, '=', "");   //Param  8
    misc+=sip.Add("optimization",           1, '=', "");   //Param  9
    misc+=sip.Add("no_transformations",     1, '=', "");   //Param 10
    misc+=sip.Add("record_transformations", 1, '=', "");   //Param 11
    misc+=sip.Add("go",                     0, ch,  "");   //Param 12
    misc+=sip.Add("file_info",              1, '=', "");   //Param 13
    misc+=sip.Add("go1",                    0, ch,  "");   //Param 14
    misc+=sip.Add("file_diag_out_append",   1, '=', "");   //Param 15
    misc+=sip.Add("go2",                    0, ch,  "");   //Param 16
    misc+=sip.Add("optimization1",          1, '=', "");   //Param 17
    misc+=sip.Add("file_time_out",          1, '=', "");   //Param 18
    misc+=sip.Add("go3",                    0, ch,  "");   //Param 19
    misc+=sip.Add("param_tile1",            1, '=', "");   //Param 20
    misc+=sip.Add("param_tile2",            1, '=', "");   //Param 21
    misc+=sip.Add("param_tile3",            1, '=', "");   //Param 22
    misc+=sip.Add("param_unroll1",          1, '=', "");   //Param 23
    misc+=sip.Add("param_unroll2",          1, '=', "");   //Param 24
    misc+=sip.Add("param_unroll3",          1, '=', "");   //Param 25
    misc+=sip.Add("param_pad1",             1, '=', "");   //Param 26
    misc+=sip.Add("param_pad2",             1, '=', "");   //Param 27
    misc+=sip.Add("param_pad3",             1, '=', "");   //Param 28
    misc+=sip.Add("ignore_incorrect_out",   1, '=', "");   //Param 29
    misc+=sip.Add("start_from_beginning",   1, '=', "");   //Param 30
    misc+=sip.Add("file_project_out",       1, '=', "");   //Param 31
    misc+=sip.Add("file_info_out",          1, '=', "");   //Param 32
    misc+=sip.Add("go4",                    0, ch,  "");   //Param 33
    misc+=sip.Add("go5",                    0, ch,  "");   //Param 34
    misc+=sip.Add("param_grid",             1, '=', "");   //Param 35
    misc+=sip.Add("param_rnd",              1, '=', "");   //Param 36
    misc+=sip.Add("file_time_in",           1, '=', "");   //Param 37
    misc+=sip.Add("array_pad_only",         1, '=', "");   //Param 38
    misc+=sip.Add("go6",                    0, ch,  "");   //Param 39
    misc+=sip.Add("create_dirs_each_step",  1, '=', "");   //Param 40
    misc+=sip.Add("go2a",                   0, ch,  "");   //Param 41
    misc+=sip.Add("go3a",                   0, ch,  "");   //Param 42
    misc+=sip.Add("dir_ic",                 1, '=', "");   //Param 43
    misc+=sip.Add("number_of_executions",   1, '=', "");   //Param 44

    if (misc!=0)
    {
      System.out.println("\nError: Internal, while initializing CSIParse!");
      return;
    }

    //Process Instructions
    new ProcessInstructions(sockfd, g, sip);
  }      
}
