/*--------------------------------------------------------------------+
 | OCTAVE - Optimising Compiler Tool And Visualisation Environment    |
 |                                                                    |
 | Copyright (C) University of Edinburgh, 1993.                       |
 |                                                                    |
 | OCTAVE is free software; you can redistribute it and/or modify     |
 | it under the terms of the GNU General Public License as published  |
 | by the Free Software Foundation; either version 1, or (at your     |
 | option) any later version.                                         |
 |                                                                    |
 | OCTAVE is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of     |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
 | GNU General Public License for more details.                       |
 |                                                                    |
 | You should have received a copy of the GNU General Public License  |
 | along with OCTAVE; see the file COPYING.  If not, write to         |
 | the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,   |
 | USA.                                                               |
 +--------------------------------------------------------------------*/

#if ! defined _globals_h_
#define _globals_h_

#include "Strings.h"
#include "Defs.h"

// CLASS GROUP: parser support classes

/*--------------------------------------------------------------------

CLASS
    parse_constants

    Constant parser objects, grouped here for convenience.
    All string constants are declared static, and are created once
    only.
---------------------------------------------------------------------*/

class parse_constants {
public:

    ////////////////////////////////
    //
  parse_constants () ;

    ////////////////////////////////
    //
  PTR_TYPE global_unsigned_int ;

    ////////////////////////////////
    //
  PTR_TYPE global_int ;

    ////////////////////////////////
    //
  PTR_TYPE global_unsigned_short_int ;

    ////////////////////////////////
    //
  PTR_TYPE global_unsigned_long_int ;

    ////////////////////////////////
    //
  PTR_TYPE global_long_int ;

    ////////////////////////////////
    //
  PTR_TYPE global_short_int ;

    ////////////////////////////////
    //
    // Convex Fortran extension
    //
  PTR_TYPE global_byte ;

    ////////////////////////////////
    //
  PTR_TYPE global_float ;

    ////////////////////////////////
    //
  PTR_TYPE global_double ;

    ////////////////////////////////
    //
  PTR_TYPE global_long_double ;

    ////////////////////////////////
    //
  PTR_TYPE global_char ;

    ////////////////////////////////
    //
  PTR_TYPE global_signed_char ;

    ////////////////////////////////
    //
  PTR_TYPE global_unsigned_char ;

    ////////////////////////////////
    //
  PTR_TYPE global_wchart ;

    ////////////////////////////////
    //
  PTR_TYPE global_string ;

    ////////////////////////////////
    //
  PTR_TYPE global_bool ;

    ////////////////////////////////
    //
  PTR_TYPE global_complex ;

    ////////////////////////////////
    //
  PTR_TYPE global_gate ;

    ////////////////////////////////
    //
  PTR_TYPE global_event ;

    ////////////////////////////////
    //
  PTR_TYPE global_void ;

    ////////////////////////////////
    //
  PTR_TYPE global_sequence ;

    ////////////////////////////////
    //
  PTR_TYPE global_default ;

    ////////////////////////////////
    //
  PTR_TYPE global_unknown ;

    ////////////////////////////////
    //
  PTR_TYPE global_auto ;

    ////////////////////////////////
    //
  PTR_TYPE global_register ;

    ////////////////////////////////
    //
  PTR_TYPE global_static ;

    ////////////////////////////////
    //
  PTR_TYPE global_extern ;

    ////////////////////////////////
    //
  PTR_TYPE global_explicit ;

    ////////////////////////////////
    //
  PTR_TYPE global_short ;

    ////////////////////////////////
    //
  PTR_TYPE global_long ;

    ////////////////////////////////
    //
  PTR_TYPE global_signed ;

    ////////////////////////////////
    //
  PTR_TYPE global_unsigned ;

    ////////////////////////////////
    //
  PTR_TYPE global_inline ;

    ////////////////////////////////
    //
  PTR_TYPE global_virtual ;

    ////////////////////////////////
    //
  PTR_TYPE global_friend ;

    ////////////////////////////////
    //
  PTR_TYPE global_typedef ;

    ////////////////////////////////
    //
  PTR_TYPE global_const ;

    ////////////////////////////////
    //
  PTR_TYPE global_volatile ;


    ////////////////////////////////
    //
  PTR_TYPE global_mutable ;

    ////////////////////////////////
    //
  PTR_SYMB star_symb ;

    ////////////////////////////////
    //
  PTR_SYMB ellipsis_symb ;

    ////////////////////////////////
    //
  static string   star_string ;     // "*"

    ////////////////////////////////
    //
  static string   ellipsis_string ; // "..."

    ////////////////////////////////
    //
  static string   unit_string ;     // "unit"

    ////////////////////////////////
    //
  static string   dbl_star_string ; // "**"

    ////////////////////////////////
    //
  static string   fmt_string ;      // "fmt"

    ////////////////////////////////
    //
  static string   nml_string ;      // "nml"
};

#endif // _globals_h_
