#ifndef _tokdefs_h_
#define _tokdefs_h_

#include "Octave/Base/Strings.h"
#include "Octave/Base/Defs.h"
#include "Octave/Base/Tags.h"
#include "Octave/Base/ParseContext.h"

#define YY_DECL int yyFlexLexer::yylex (YYSTYPE* lval)
#define YYSTYPE token_t

class YYSTYPE {
public:
    int token ;
    statement_tag stmt_tag ;
    expression_tag expr_tag ;
    char charv ;
    int ival ;
    string *stringp ;
    PTR_STMT bf_node ;
    PTR_EXPR ll_node ;
    PTR_SYMB symbol ;
    PTR_TYPE data_type ;
    PTR_HASH hash_entry ;
    PTR_FTN_LABEL label ;
};

#define PERCENT 1001
#define AMPERSAND 1002
#define ASTER 1003
#define CLUSTER 1004
#define COLON 1005
#define COMMA 1006
#define DASTER 1007
#define DEFINED_OPERATOR 1008
#define DOT 1009
#define DQUOTE 1010
#define GLOBAL_A 1011
#define LEFTAB 1012
#define LEFTPAR 1013
#define MINUS 1014
#define PLUS 1015
#define POINT_TO 1016
#define QUOTE 1017
#define RIGHTAB 1018
#define RIGHTPAR 1019
#define SHARP 1020
#define AND 1021
#define DSLASH 1022
#define EQV 1023
#define EQ 1024
#define EQUAL 1025
#define FALSE_VAL 1026
#define GE 1027
#define GT 1028
#define LE 1029
#define LT 1030
#define NE 1031
#define NEQV 1032
#define NOT 1033
#define OR 1034
#define TRUE_VAL 1035
#define SLASH 1036
#define XOR 1037
#define REFERENCE 1038
#define ACCEPT 1039
#define ALIGN 1040
#define ALLOCATABLE 1041
#define ALLOCATE 1042
#define ARITHIF 1043
#define ASSIGN 1044
#define ASSIGNGOTO 1045
#define ASSIGNMENT 1046
#define ASSIGN_LOCK 1047
#define ASSOCIATE_VARIABLE 1048
#define BACKSPACE 1049
#define BAD_CCONST 1050
#define BAD_SYMBOL 1051
#define BEGIN_ORDER 1052
#define BEGIN_SECTION 1053
#define BEGIN_TASKS 1054
#define BLANK_STATEMENT 1055
#define BLOCK 1056
#define BLOCKDATA 1057
#define BLOCK_CYCLIC 1058
#define BYTE 1059
#define CALL 1060
#define CASE 1061
#define CDOACROSS 1062
#define CDOALL 1063
#define CHARACTER 1064
#define CHAR_CONSTANT 1065
#define CLEAR 1066
#define CLOOP 1067
#define CLOSE 1068
#define COMMENT 1069
#define COMMON 1070
#define COMPGOTO 1071
#define COMPLEX 1072
#define CONCURRENT 1073
#define CONSTRUCT_ID 1074
#define CONTAINS 1075
#define CONTINUE 1076
#define CRITICALSECTION 1077
#define CYCLE 1078
#define CYCLIC 1079
#define DATA 1080
#define DEALLOCATE 1081
#define DECODE 1082
#define DECOMPOSITION 1083
#define DEFAULT_CASE 1084
#define DEFINE 1085
#define DIMENSION 1086
#define DIRECTIVE 1087
#define DISTRIBUTE 1088
#define DOACROSS 1089
#define DOUBLECOMPLEX 1090
#define DOUBLEPRECISION 1091
#define DOWHILE 1092
#define DP_CONSTANT 1093
#define ELSE 1094
#define ELSEIF 1095
#define ELSEWHERE 1096
#define ENCODE 1097
#define ENDCDOACROSS 1098
#define ENDCDOALL 1099
#define ENDCLOOP 1100
#define ENDCONCURRENT 1101
#define ENDCRITICALSECTION 1102
#define ENDDO 1103
#define ENDDOACROSS 1104
#define ENDEXTEND 1105
#define ENDEXTENDED 1106
#define ENDFILE 1107
#define ENDIF 1108
#define ENDINTERFACE 1109
#define ENDMODULE 1110
#define ENDPARALLEL 1111
#define ENDPARALLELDO 1112
#define ENDPARALLELSECTIONS 1113
#define ENDPDO 1114
#define ENDPSECTIONS 1115
#define ENDSDOALL 1116
#define ENDSECTIONS 1117
#define ENDSELECT 1118
#define ENDSINGLEPROCESS 1119
#define ENDTYPE 1120
#define ENDUNIT 1121
#define ENDWHERE 1122
#define END_ORDER 1123
#define END_SECTION 1124
#define END_TASKS 1125
#define ENTRY 1126
#define EOLN 1127
#define EQUIVALENCE 1128
#define ERROR 1129
#define EVENT 1130
#define EXIST 1131
#define EXIT 1132
#define EXTEND 1133
#define EXTENDED 1134
#define EXTERNAL 1135
#define FIND 1136
#define FORALL 1137
#define FORALLDO 1138
#define FORCE_PARALLEL 1139
#define FORCE_PARALLEL_EXT 1140
#define FORCE_VECTOR 1141
#define FORMAT_TOKEN 1142
#define FREE_LOCK 1143
#define FUNCTION 1144
#define GATE 1145
#define GUARDS 1146
#define HEX_CONSTANT 1147
#define HOLLERITH 1148
#define IDENTIFIER 1149
#define IMPLICIT 1150
#define IMPLICITNONE 1151
#define IN 1152
#define INCLUDE 1153
#define INOUT 1154
#define INQUIRE 1155
#define INTEGER 1156
#define INTENT 1157
#define INTERFACE 1158
#define INTERFACEASSIGNMENT 1159
#define INTERFACEOPERATOR 1160
#define INTRINSIC 1161
#define INT_CONSTANT 1162
#define LABEL 1163
#define LABEL_DECLARE 1164
#define LET 1165
#define LOCK 1166
#define LOGICAL 1167
#define LOGICALIF 1168
#define LOOP 1169
#define MAXPARALLEL 1170
#define MAX_TRIPS 1171
#define MODULE 1172
#define NAMEEQ 1173
#define NAMELIST 1174
#define NEW_STATEMENT 1175
#define NEXT_TASK 1176
#define NO_PARALLEL 1177
#define NO_PEEL 1178
#define NO_PROMOTE_ALL 1179
#define NO_PROMOTE_TEST 1180
#define NO_RECURRENCE 1181
#define NO_SIDE_EFFECTS 1182
#define NO_VECTOR 1183
#define NULLIFY 1184
#define OCTAL_CONSTANT 1185
#define ON 1186
#define ONLY 1187
#define OPEN 1188
#define OPERATOR 1189
#define OPTIONAL 1190
#define OPTIONS 1191
#define ORDERED 1192
#define OTHERWISE 1193
#define OUT 1194
#define PARALLEL 1195
#define PARALLELDO 1196
#define PARALLELSECTIONS 1197
#define PARAMETER 1198
#define PAUSE 1199
#define PDO 1200
#define PEEL 1201
#define PEEL_ALL 1202
#define PLAINDO 1203
#define PLAINGOTO 1204
#define POINTER 1205
#define POINTERLET 1206
#define POST 1207
#define PREFER_PARALLEL 1208
#define PREFER_PARALLEL_EXT 1209
#define PREFER_VECTOR 1210
#define PRINT 1211
#define PRIVATE 1212
#define PROCEDURE 1213
#define PROCESS_CLUSTER 1214
#define PROCESS_GLOBAL 1215
#define PROGRAM 1216
#define PROMOTE_TEST 1217
#define PROMOTE_TEST_ALL 1218
#define PSECTIONS 1219
#define PSTRIP 1220
#define PUBLIC 1221
#define RANGE 1222
#define READ 1223
#define REAL 1224
#define REAL_CONSTANT 1225
#define RECORD 1226
#define RECURSIVE 1227
#define REDUCE 1228
#define RELEASE 1229
#define RESULT 1230
#define RETURN 1231
#define REWIND 1232
#define ROW_WISE 1233
#define SAVE 1234
#define SCALAR 1235
#define SCOMMON 1236
#define SDOALL 1237
#define SECTION 1238
#define SECTIONWAIT 1239
#define SELECT 1240
#define SEQUENCE 1241
#define SET 1242
#define SHORT_COMMENT 1243
#define SINGLEPROCESS 1244
#define SKIPPASTEOF 1245
#define STAT 1246
#define STOP 1247
#define SUBROUTINE 1248
#define SYNC 1249
#define SYNCH_PARALLEL 1250
#define TARGET 1251
#define TASK_CLUSTER 1252
#define TASK_COMMON 1253
#define TASK_GLOBAL 1254
#define THEN 1255
#define TO 1256
#define TRUNC 1257
#define TYPE 1258
#define TYPE_DECL 1259
#define UNKNOWN_TOK 1260
#define UNLOCK 1261
#define UNROLL 1262
#define USE 1263
#define VARIABLE 1264
#define VIRTUAL 1265
#define VSTRIP 1266
#define WAIT 1267
#define WHERE 1268
#define WHERE_ASSIGN 1269
#define WHILE 1270
#define WITH 1271
#define WRAP 1272
#define WRITE 1273
#endif
