/*
 * MPC Feedback Module 2 for ATOM (analysis)
 *
 * Copyright (C) 2000-2004 by Grigori G. Fursin
 *
 * homepage: http://homepages.inf.ed.ac.uk/gfursin
 *
 * ICSA, School of Informatics,
 * University of Edinburgh, UK
 */

#include <stdio.h>
#include <assert.h>

char procname[1024];

FILE *fmpc1;
FILE *fmpc2;

unsigned long int* InstrPerProc;
int proc_max=0;

void MPCInit(int proc_max1)
{
  int i;

  proc_max=proc_max1;

  fprintf(stderr, "ATOM (eos_mpc_fb2): Allocating %u bytes of memory [InstPerProc]...\n", proc_max*8);

  InstrPerProc=(unsigned long int*) calloc(sizeof(unsigned long int), proc_max);

  if (InstrPerProc == NULL) 
  {
    fprintf(stderr,"\nFatal Error (ATOM, eos_mpc_fb2): Can't allocate memory!\n");
    exit(1);
  }

  for (i=0; i<proc_max1; i++) InstrPerProc[i]=0;
}

void MPCProcCount(int proc, int num_of_instr)
{
  InstrPerProc[proc]+=(unsigned long int) num_of_instr;
}

void MPCFinish(void)
{
  int i=0;

  fprintf(stderr, "\nATOM (eos_mpc_fb2): Saving collected data ...\n");

  if ((fmpc1=fopen("_eos_mpc_fb2.out","wt"))==NULL)
  {
    fprintf(stderr, "\nFatal Error: Can't write results!\n");
    exit(1);
  }

  if ((fmpc2=fopen("_eos_mpc_fb2.dat","rt"))==NULL)
  {
    fprintf(stderr, "\nFatal Error: Can't find file with parameters!\n");
    exit(1);
  }

  for (i=0; i<proc_max; i++)
  {
    fscanf(fmpc2, "%s", &procname[0]);

    fprintf(fmpc1, "instr={%20ld}, proc={%s}\n", InstrPerProc[i], procname);
  }

  fclose(fmpc2);
  fclose(fmpc1);

  fprintf(stderr, "ATOM (eos_mpc_fb2): Data saved successfully!\n");
}
